diff --git a/contrib/dblink/dblink.c b/contrib/dblink/dblink.c
index 2fe5da2..7364332 100644
*** a/contrib/dblink/dblink.c
--- b/contrib/dblink/dblink.c
*************** dblink_connect(PG_FUNCTION_ARGS)
*** 298,305 ****
--- 298,310 ----
  		conname_or_str = text_to_cstring(PG_GETARG_TEXT_PP(0));
  
  	if (connname)
+ 	{
  		rconn = (remoteConn *) MemoryContextAlloc(TopMemoryContext,
  												  sizeof(remoteConn));
+ 		rconn->conn = NULL;
+ 		rconn->openCursorCount = 0;
+ 		rconn->newXactForCursor = false;
+ 	}
  
  	/* first check for valid foreign data server */
  	connstr = get_connect_string(conname_or_str);
